#ifndef TEMPLATEPARSE_INTERNAL_H
#define TEMPLATEPARSE_INTERNAL_H

#include "util.h"
#include "atomic.h"

#include <stdarg.h>

/*
 * The macros in here are to be used by the code generated by the template compiler.
 */

struct gperf_ph_elem {
	const char *name;
	union {
		const char *value;
		struct template_opaque_var var;
	} u;
};

#define INIT_CACHE(a)
#define CACHE_ON(a)
#define CACHE_OFF
static void __attribute__((__unused__)) clear_cache(void) {}

/* For now, the cache code is disabled because it makes things slower and the cache invalidation is unstable. */
#define TEMPLATE_VAR_NO_CACHE
#ifdef TEMPLATE_VAR_NO_CACHE
#define TEMPLATE_VAR_DECL(name)
#define TEMPLATE_VAR_INIT {}
#define TEMPLATE_VAR(t_name, name) \
 \
static inline int UNUSED \
__##name##_listlen(struct __vars_##t_name *v, struct bpapi *api) { \
	return template_listlen(api, #name); \
} \
 \
static inline const char * UNUSED \
__##name##_getvar(struct __vars_##t_name *v, struct bpapi *api) { \
	return template_getvar(api, #name); \
} \
 \
static inline const char * UNUSED \
__##name##_getlist(struct __vars_##t_name *v, struct bpapi *api, int pos) { \
	return template_getlist(api, #name, pos); \
} \
 \
static inline int UNUSED \
__##name##_ifdef(struct __vars_##t_name *v, struct bpapi *api) { \
	return template_ifdef(api, #name); \
} \
 \
static inline void UNUSED \
__##name##_fetchlist(struct __vars_##t_name *v, struct bpapi *api, struct bpapi_loop_var *loop) { \
	template_fetchlist(api, #name, loop); \
}
#else
#define TEMPLATE_VAR_DECL(name) struct template_var name;
#define TEMPLATE_VAR_INIT {{0}}
#define TEMPLATE_VAR(t_name, name)				\
								\
static void UNUSED						\
__##name##_init(struct __vars_##t_name *v, struct bpapi *api) {	\
	bpapi_init_var(api, #name, &(v->name));			\
}								\
								\
static int UNUSED						\
__##name##_listlen(struct __vars_##t_name *v, 			\
		struct bpapi *api) {				\
	if (v->name.initialized != api->schain.cache_gen) {	\
		__##name##_init(v, api);			\
		if (v->name.initialized != api->schain.cache_gen) \
			return template_listlen(api, #name);	\
	}							\
								\
	if (!v->name.entry)					\
		return 0;					\
								\
	return v->name.entry->len;				\
}								\
								\
static const char*						\
__##name##_getvar(struct __vars_##t_name *v, 			\
		struct bpapi*) UNUSED;				\
								\
static const char*						\
__##name##_getvar(struct __vars_##t_name *v, 			\
		struct bpapi *api) {				\
	if (v->name.initialized != api->schain.cache_gen) {	\
		__##name##_init(v, api);			\
		if (v->name.initialized != api->schain.cache_gen) \
			return template_getvar(api, #name);	\
	}							\
								\
	if (!v->name.entry)					\
		return "";					\
								\
	if (!v->name.entry->valuelist)				\
		return template_getvar(api, #name);		\
								\
	return v->name.entry->valuelist[0];			\
} 								\
								\
static const char*						\
__##name##_getlist(struct __vars_##t_name *v, 			\
		struct bpapi*,int) UNUSED;			\
								\
static const char* UNUSED					\
__##name##_getlist(struct __vars_##t_name *v, 			\
		struct bpapi *api, int pos) {			\
	if (v->name.initialized != api->schain.cache_gen) {	\
		__##name##_init(v, api);			\
		if (v->name.initialized != api->schain.cache_gen) \
			return template_getlist(api, #name, pos); \
	}							\
								\
	if (!v->name.entry)					\
		return "";					\
								\
	if (!v->name.entry->valuelist)				\
		return template_getlist(api, #name, pos);	\
								\
	return v->name.entry->valuelist[pos % v->name.entry->len]; \
}								\
								\
static int UNUSED						\
__##name##_ifdef(struct __vars_##t_name *v, 			\
		struct bpapi *api) {				\
	if (v->name.initialized != api->schain.cache_gen) {	\
		__##name##_init(v, api);			\
		if (v->name.initialized != api->schain.cache_gen) \
			return template_ifdef(api, #name);	\
	}							\
								\
	return v->name.entry != NULL;				\
}								\
								\
static void UNUSED						\
__##name##_fetchlist(struct __vars_##t_name *v,			\
		struct bpapi *api, struct bpapi_loop_var *loop) { \
	if (v->name.initialized != api->schain.cache_gen) {	\
		__##name##_init(v, api);			\
		if (v->name.initialized != api->schain.cache_gen) { \
			template_fetchlist(api, #name, loop);	\
			return;					\
		}						\
	}							\
								\
	if (!v->name.entry) {					\
		loop->len = 0;					\
		loop->l.list = NULL;				\
		loop->cleanup = NULL;				\
		return;						\
	}							\
								\
	if (!v->name.entry->valuelist) {			\
		template_fetchlist(api, #name, loop);		\
		return;						\
	}							\
								\
	loop->len = v->name.entry->len;				\
	loop->l.list = v->name.entry->valuelist;			\
	loop->cleanup = NULL;					\
}
#endif

#define TEMPLATE_ARG_VAR(t_name, name, idx) \
 \
static inline int UNUSED \
__##name##_listlen(struct __vars_##t_name *v, struct bpapi *api) { \
	return idx < v->argc ? 1 : 0; \
} \
 \
static inline const char * \
__##name##_getvar(struct __vars_##t_name *v, struct bpapi *api) { \
	if (idx < v->argc) { \
		return v->args[idx] ?: ""; \
	} \
	return ""; \
} \
 \
static inline const char * UNUSED \
__##name##_getlist(struct __vars_##t_name *v, struct bpapi *api, int pos) { \
	return __##name##_getvar(v, api); \
} \
 \
static inline int UNUSED \
__##name##_ifdef(struct __vars_##t_name *v, struct bpapi *api) { \
	return idx < v->argc ? 1 : 0; \
} \
 \
static inline void UNUSED \
__##name##_fetchlist(struct __vars_##t_name *v, struct bpapi *api, struct bpapi_loop_var *loop) { \
	/* XXX support this (doesn't really make sense though) */ \
	loop->len = 0; \
	loop->cleanup = NULL; \
}

#define TEMPLATE_FILTERBODY_VAR(t_name, name) TEMPLATE_ARG_VAR(t_name, name, 0)

#define template_vtree_get(api, cc, cache, ...) (vtree_get_cache(&(api)->vchain, cc, cache, __VA_ARGS__) ?: "")
#define template_vtree_haskey(api, cc, cache, ...) vtree_haskey_cache(&(api)->vchain, cc, cache, __VA_ARGS__)
#define template_vtree_getlen(api, cc, cache, ...) vtree_getlen_cache(&(api)->vchain, cc, cache, __VA_ARGS__)
#define template_vtree_fetch_keys(api, loop, cc, ...) vtree_fetch_keys_cache(&(api)->vchain, loop, cc, __VA_ARGS__)
#define template_vtree_fetch_values(api, loop, cc, ...) vtree_fetch_values_cache(&(api)->vchain, loop, cc, __VA_ARGS__)
#define template_vtree_fetch_byval(api, loop, cc, value, ...) vtree_fetch_keys_by_value_cache(&(api)->vchain, loop, cc, value, __VA_ARGS__)
#define template_vtree_getnode(api, cc, dst, ...) vtree_getnode_cache(&(api)->vchain, cc, dst, __VA_ARGS__)

#if 0
const char *template_vtree_get(struct bpapi *api, enum bpcacheable *cc, const char **cache, ...);
int template_vtree_haskey(struct bpapi *api, enum bpcacheable *cc, int *cache, ...);
int template_vtree_getlen(struct bpapi *api, enum bpcacheable *cc, int *cache, ...);
void template_vtree_fetch_keys(struct bpapi *api, struct bpapi_loop_var *loop, enum bpcacheable *cc, ...);
void template_vtree_fetch_values(struct bpapi *api, struct bpapi_loop_var *loop, enum bpcacheable *cc, ...);
void template_vtree_fetch_byval(struct bpapi *api, struct bpapi_loop_var *loop, enum bpcacheable *cc, const struct tpvar *value, ...);
#endif

#define template_output(api, str) do { const char *__str = (str); if (__str) bpapi_outstring_raw((api), __str, __builtin_choose_expr(__builtin_constant_p(str), sizeof(str) - 1, strlen(__str))); } while (0)
#define template_output_int(api, i) bpapi_outstring_fmt((api), "%d", (i))
void template_output_var(struct bpapi *api, const struct tpvar *var);

#define template_ifdef(api, key) bpapi_has_key((api), (key))
int template_ifdef_var(struct bpapi *api, const struct tpvar *var);
#define template_getvar(api, key) (bpapi_get_element((api), (key), 0) ?: "")
const char *template_getvar_var(struct bpapi *api, const struct tpvar *var);
#define template_getlist(api, key, pos) (bpapi_get_element((api), (key), (pos)) ?: "")
const char *template_getlist_var(struct bpapi *api, const struct tpvar *var, int pos);
#define template_listlen(api, key) bpapi_length((api), (key))
int template_listlen_var(struct bpapi *api, const struct tpvar *var);
#define template_fetchlist(api, key, loop) bpapi_fetch_loop((api), (key), (loop))
void template_fetchlist_var(struct bpapi *api, const struct tpvar *var, struct bpapi_loop_var *loop);
#define template_fetchglob(api, key, loop) bpapi_fetch_glob_loop((api), (key), (loop))
void template_fetchglob_var(struct bpapi *api, const struct tpvar *var, struct bpapi_loop_var *loop);
void template_define_var(struct bpapi *api, const struct tpvar *var, const struct tpvar *val);

#define template_compare_str(l, r) (__extension__({ const char *__l = (l), *__r = (r); int __ld = strlen(__l) - strlen(__r); (__ld != 0 ? __ld : strcmp(__l, __r)); }))

int template_compare_vars(const struct tpvar *, const struct tpvar *);
int template_regcompare(const char*, const char*);
int template_regcompare_vars(const struct tpvar *, const struct tpvar *);

struct deffilter_data {
	struct buf_string buf;
	struct bpapi *api;
	int argc;
	const struct tpvar **argv;
};

#ifndef TEMPLATE_WEAK
#define TEMPLATE_WEAK __attribute__((__weak__))
#endif

#define TEMPLATE_DEFFILTER(name, tmpl) \
	TEMPLATE_DEFFILTER_WITH_ATTR(name, tmpl,)

#define TEMPLATE_DEFFILTER_WITH_ATTR(name, tmpl, attr) \
static int \
init_ ## name(const struct bpfilter *filter, struct bpapi *api, int argc, const struct tpvar **argv) { \
	struct deffilter_data *data = BPAPI_OUTPUT_DATA(api); \
	data->api = api; \
	data->argc = argc; \
	data->argv = argv; \
	return 0; \
} \
struct bpapi_output name ## _output attr = { \
	bufstring_outstring_fmt, \
	bufstring_outstring_raw, \
	tmpl, \
	NULL \
}; \
ADD_OUTPUT_FILTER_WITH_ATTR(name, sizeof(struct deffilter_data), attr);

#define TEMPLATE_DEFFILTER_WEAK(name, tmpl) \
	TEMPLATE_DEFFILTER_WITH_ATTR(name, tmpl, TEMPLATE_WEAK)


void init_filter(const struct bpfilter * __restrict filter, struct bpapi * __restrict api, struct bpapi * __restrict old_api, void * __restrict v, int * __restrict ofilters);
void deinit_filter(const struct bpfilter * __restrict filter, struct bpapi * __restrict api, struct bpapi * __restrict old_api);

/*
 * This allocates storage for the filters internal data and calls init_filter.
 * We'd prefer to allocate with alloca or something like that, but unfortunately alloca memory
 * have a life time for the entirety of a function. Since this can be called in loops within
 * the same very long function we can potentially end up running out of stack with alloca.
 * VLAs don't have that problem, so we need to use a VLA aligned to a void *. Potentially
 * void * is not the best alignment, so we might need to bump this to the largest alignment
 * type in the future. Possibly long double?
 */

#define TMPL_F_ROUND(x) ((((x) + sizeof(void *) - 1) / sizeof(void *)) * sizeof(void *))
#define TMPL_FILTER_INIT(tfname, napi, api, ofilters) \
	size_t fdata_sz; \
	fdata_sz  = TMPL_F_ROUND(tfname.output_sz); \
	fdata_sz += TMPL_F_ROUND(tfname.simplevars_sz); \
	fdata_sz += TMPL_F_ROUND(tfname.vtree_sz); \
	void *dbuf[fdata_sz / sizeof(void *)]; \
	init_filter(& tfname, napi, api, dbuf, ofilters);

/*
 * Macros for setting up and finalizing the globally cached loops (vtree loops).
 */
#define TMPL_CACHED_LOOP_PREPARE(gl, ll, cc_l, cacheable, ...) \
	if (gl.len > -1) { \
		*ll = gl; \
		ll->cleanup = NULL; \
		cc_l = BPCACHE_USED; \
	} else { \
		__VA_ARGS__ \
	} \
	if (cc_l < cacheable) { \
		cacheable = cc_l; \
	}

void tmpl_cached_loop_finalize(struct bpapi_loop_var * __restrict gl, struct bpapi_loop_var * __restrict ll, enum bpcacheable cc_l);

#define TMPL_CACHED_LOOP_FINALIZE(gl, ll, cc_l) \
	if (cc_l != BPCACHE_USED) { \
		tmpl_cached_loop_finalize(&gl, ll, cc_l); \
	}

/*
 * Prettier loop variable access
 */
#define TMPL_L_VAR(var, cnt) (var->len ? var->l.list[cnt % var->len] : "")

#endif
